// । 3D-  㭪 ஥஢

#ifndef __EXAMPLE_3D_H
#define __EXAMPLE_3D_H

// ࠧ ࠭  ﭨ   ।  video.h
#include "video.h"

//  "設"
typedef struct {
  float x, y, z;       // न 設
  float rx, ry, rz;    // ८ࠧ (eg, ) न 設
  float sx, sy;        // ࠭ (஥஢) न 設
  float u, v;          // ᮮ⢥騥  न ⥪
  float uz, vz, z1;    // u/z, v/z, 1/z ( ᯥ⨢-᪮४஢)
  float nx, ny, nz;    // न  ଠ  設
  float rnx, rny, rnz; // ८ࠧ (eg, ) न ଠ
  float cc;            // ᢥ饭 設 ( ᢥ饭  )
} vertex;

//  "࠭"
typedef struct {
  vertex *v1, *v2, *v3; // 㪠⥫  設 ࠭
  char *texture;        // 㪠⥫  ⥪
  float nx, ny, nz;     // न  ଠ  ࠭
} face;

// 㭪 ஥஢ 設
void projectVertex(vertex *v) {
  v->sx = XSIZE/2 + v->rx * DIST / (v->rz + DIST);
  v->sy = YSIZE/2 - v->ry * DIST / (v->rz + DIST);
}

//  設 ⭮⥫쭮  Ox  㣮 angle
void xRotateVertex(vertex *v, float angle) {
  register float mysin = sin(angle);
  register float mycos = cos(angle);

  // 稢 ᠬ 
  v->rx = v->x;
  v->rz = v->z * mycos - v->y * mysin;
  v->ry = v->z * mysin + v->y * mycos;

  // 稢 ଠ  ꥪ  ⮩ 窥
  v->rnx = v->nx;
  v->rnz = v->nz * mycos - v->ny * mysin;
  v->rny = v->nz * mysin + v->ny * mycos;
}

#endif
